#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2nine4search.py">
#<abstract4xi abstract = "shoots to direction nine"/>
#<refer4xi reference = "analyse2photo4search.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2nine4search']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 


#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI   
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2nine4search: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2nine4search: *** error: from process4xi import Process4Xi ***")    
     
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global base2build4nine

global count2ack4nine
global count2nack4nine
global count2found4nine
global count2short4nine

global current2series4nine
global candidate2series4nine

global fileobject4nine  

global keys2profile4nine
global key2profile4nine

global left2find4nine

global maxsize2ack4nine    
global maxsize2file4nine 
global max2short4nine
global meansize2ack4nine
global minsize2ack4nine

global nine2analyse4search

global profile2fetch4nine

global right2find4nine

global sumsize2ack4nine    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2build4nine = VersionKB4Xi['base2shoot4nine']             # base internet address, None=local url

count2ack4nine   = 0
count2nack4nine  = 0
count2found4nine = 0
count2short4nine = 0

left2find4nine = '('

max2short4nine = VersionKB4Xi['max2short4nine']
maxsize2file4nine = VersionKB4Xi['maxsize2file4nine']
maxsize2ack4nine  = 0
meansize2ack4nine = 0
minsize2ack4nine  = 0

current2series4nine = "current2series4nine5dummy"
candidate2series4nine  = "candidate2series4nine5dummy"


nine2analyse4search  = VersionKB4Xi['nine2analyse4search']

profile2fetch4nine = {}
profile2fetch4nine [1] = '.JPG'                             # object types to be aceepted for hyperlinks
profile2fetch4nine [2] = '.jpg'
keys2profile4nine = profile2fetch4nine.keys()

right2find4nine = ')'

sumsize2ack4nine  = 0

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4nine" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4nine(target2explore4nine):
    global count2ack4nine
    global count2nack4nine
    global count2found4nine
    global count2short4nine
    
    global fileobject4nine 
       
    global keys2profile4nine
    global key2profile4nine
    
    global left2find4nine

    global max2short4nine    
    global maxsize2file4nine     
    global maxsize2ack4nine    
    global meansize2ack4nine
    global minsize2ack4nine
  
    global candidate2series4nine
    global current2series4nine
    
    
    global profile2fetch4nine                         # extension for files
    
    global right2find4nine
    
    global sumsize2ack4nine    

       
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    count2found4nine = count2found4nine + 1
    ack2debug4nine = False                            # <-- True
 
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4nine)
    
    ack2profile = False
    for key2profile4nine in keys2profile4nine:
        if name2target[1] == profile2fetch4nine[key2profile4nine]:                                                             
            ack2profile = True
    
    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF SHOOT2NINE4SEARCH - TARGET
        # -----------------------------------------------------------------------------------------
        path2input = target2explore4nine
        if ack2debug4nine is True:
            print("(STEP 0A/33) OF SHOOT2NINE4SEARCH - PATH2INPUT: ", path2input) 
            #  
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF SHOOT2NINE4SEARCH - CHECK FILE STATUS
        # -----------------------------------------------------------------------------------------
        status2file = os.stat(path2input)
        size2file = status2file.st_size
        if size2file > maxsize2file4nine:
            count2nack4nine = count2nack4nine + 1
        else:
            count2ack4nine = count2ack4nine + 1
            sumsize2ack4nine = sumsize2ack4nine + size2file
            if size2file > maxsize2ack4nine:
                maxsize2ack4nine = size2file
            if ((size2file < minsize2ack4nine) or (minsize2ack4nine == 0)):
                print("(STEP 0B/33) OF SHOOT2NINE4SEARCH - USING MINSIZE2ACK4NINE: ", minsize2ack4nine, " SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # USING MINSIZE2ACK4NINE:  0  SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2nine//d\ninefly29july2012\ninefly29july2012 (1).JPG 
                # USING MINSIZE2ACK4NINE:  3866624  SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2nine//d\ninefly29july2012\ninefly29july2012 (2).JPG
                minsize2ack4nine = size2file
                print("(STEP 0C/33) OF SHOOT2NINE4SEARCH - SET MINSIZE2ACK4NINE TO: ", minsize2ack4nine, " = SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # SET MINSIZE2ACK4NINE TO:  3866624  = SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2nine//d\ninefly29july2012\ninefly29july2012 (1).JPG
                # SET MINSIZE2ACK4NINE TO:  3538944  = SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2nine//d\ninefly29july2012\ninefly29july2012 (2).JPG
                            
        # ==========================================================================================================
        # create hyperlink to image
        # ==========================================================================================================
        try:
            url2web4nine = target2explore4nine
            if ack2debug4nine is True:print("(STEP 1A/33) OF SHOOT2NINE4SEARCH - URL2WEB4NINE: ", url2web4nine) 
                # 
            
            ack2all4web = False
            string2edit = '\\'
            string2use = '/'
            while 1:
                if ack2all4web is True:
                    break
                else:
                    index2edit=str.find(url2web4nine,string2edit)   
                    if index2edit == -1:
                        ack2all4web = True
                    else:
                        url2web4nine = url2web4nine[0:index2edit] + string2use + url2web4nine[index2edit+1:]
                        
            name2web=os.path.splitext(url2web4nine)
            shortname2web4nine = name2web[0]
            if ack2debug4nine is True:
                print("(STEP 1B/33) OF SHOOT2NINE4SEARCH - SHORTNAME2WEB4NINE: ", shortname2web4nine)
                # 
            
            string2find4nine = '/'
            ackall2found4nine = False           
            while 1:
                if ackall2found4nine is True:
                    break
                else:
                    index2find4nine=str.find(shortname2web4nine,string2find4nine)   
                    if index2find4nine == -1:
                        ackall2found4nine = True
                    else:
                        shortname2web4nine = shortname2web4nine[index2find4nine+1:]
                        
            if ack2debug4nine is True:            
                print("(STEP 1C/33) OF SHOOT2NINE4SEARCH - SHORTNAME2WEB4NINE: ", shortname2web4nine)
                # 
                
            ackall2found4nine = False 
            while 1:
                if ackall2found4nine is True:
                    break
                else:
                    index2left4nine=str.find(shortname2web4nine,left2find4nine)
                    if index2left4nine == -1:
                        current2series4nine = shortname2web4nine
                        if ack2debug4nine is True:
                            print("(STEP 2A/33) OF SHOOT2NINE4SEARCH - CURRENT2SERIES4NINE: ", current2series4nine) 
                            # 
                        ackall2found4nine = True
                         
                    else:
                        index2right4nine=str.find(shortname2web4nine,right2find4nine)
                        if index2right4nine == -1:
                            ackall2found4nine = True 
                        else:
                            candidate2series4nine = shortname2web4nine[0:index2left4nine]
                            
                            index3find4nine=str.find(shortname2web4nine,current2series4nine)
                            if index3find4nine == -1:
                                
                                current2series4nine = candidate2series4nine
                                if ack2debug4nine is True:
                                    print("(STEP 2B/33) OF SHOOT2NINE4SEARCH - CURRENT2SERIES4NINE: ", current2series4nine) 
                                    # 
                                
                                count2short4nine = 0
                                fileobject4nine.write('<br />' + '\n')
                            else:
                                shortname2web4nine = shortname2web4nine[index2left4nine:index2right4nine+1]
                                if ack2debug4nine is True:
                                    print("(STEP 2C/33) OF SHOOT2NINE4SEARCH - SHORTNAME2WEB4NINE: ", shortname2web4nine)
                                    # 
                                
                                count2short4nine = count2short4nine + 1
                                if count2short4nine >= max2short4nine:
                                    count2short4nine = 0
                                else:
                                    pass       
                            ackall2found4nine = True
   
                                  
            # =======================================================================================================================
            # 
            # =======================================================================================================================                    
            if base2build4nine is None:
                # ===================================================================================================================
                # LOCAL URL
                # ===================================================================================================================
                fileobject4nine.write('<br /><b>&raquo;</b><a href="' + url2web4nine + '" target="_blank">' + shortname2web4nine + '</a>\n')                       
                
            else:
                # ===================================================================================================================
                # WEB URL
                # ===================================================================================================================            
                base2local4nine = nine2analyse4search
                if ack2debug4nine is True:
                    print("(STEP 3A/33) OF SHOOT2NINE4SEARCH - BASE2LOCAL4NINE: ", base2local4nine)
                    #              
                ack2localtries4nine = False                   
                while 1:
                    if ack2localtries4nine is True:
                        break
                    else:
                        index2find4nine=str.find(url2web4nine,base2local4nine)            
                        # 
                        #  
                        if index2find4nine == -1:
                            ack2localtries4nine = True
                        else:
                            if ack2debug4nine is True:
                                print("(STEP 3B/33) OF SHOOT2NINE4SEARCH - BASE2BUILD4NINE: ", base2build4nine)
                                # 
                            url2web4nine = base2build4nine + url2web4nine[len(base2local4nine):]
                            if ack2debug4nine is True:
                                print("(STEP 3C/33) OF SHOOT2NINE4SEARCH - URL2WEB4NINE: ", url2web4nine)
                                # 
                            
                            if count2short4nine < 1: 
                                fileobject4nine.write('<br /><b>&raquo;</b><a href="' + url2web4nine + '" target="_blank">' + shortname2web4nine + '</a>' + '\n')
                            else:
                                fileobject4nine.write('<b>&raquo;</b><a href="' + url2web4nine + '" target="_blank">' + shortname2web4nine + '</a>\n')                            
                            ack2localtries4nine = True 
                        
        except:
            print("(Step 4Z1/33 OF SHOOT2NINE4SEARCH FAILED, FILEOBJECT4NINE-WRITE-FAILED: ", str(fileobject4nine), time4xi())
      
    else:
        
        count2nack4nine = count2nack4nine + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2nine4search" usage = "analysing content">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2nine4search(queue2nine = None, consumer_channel2nine = None, publisher_channel2nine = None, path2nine = None):
    '''
    communicates via the given queue and named pipe channels if multiprocessing4xi is being used 
    '''
    global count2ack4nine
    global count2nack4nine
    global count2found4nine
    
    global fileobject4nine    
    
    global maxsize2ack4nine    
    global meansize2ack4nine
    global minsize2ack4nine
    global sumsize2ack4nine    
    
    global maxsize2file4nine 
    
    global profile2fetch4nine                         # extension for files
    global keys2profile4nine
    global key2profile4nine

        
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("(STEP 0A/33) OF SHOOT2NINE4SEARCH - STARTED TIME: ", time2start)   
    # 
    print("(STEP 0B/33) OF SHOOT2NINE4SEARCH -  QUEUE2NINE: ", queue2nine)      
    # QUEUE2NINE:  <queue4xi.Queue4Xi object at 0x02A5D930>
    
    print("(STEP 0C/33) OF SHOOT2NINE4SEARCH -  CONSUMER_CHANNEL2NINE: ", consumer_channel2nine)
    # CONSUMER_CHANNEL2NINE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
          
    print("(STEP 0D/33) OF SHOOT2NINE4SEARCH -  PUBLISHER_CHANNEL2NINE: ", publisher_channel2nine)          
    # PUBLISHER_CHANNEL2NINE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>

    if ((queue2nine is None) or (consumer_channel2nine is None) or (publisher_channel2nine is None)):
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED
        # -----------------------------------------------------------------------------------------
        print("(STEP 1A/33) OF SHOOT2NINE4SEARCH - COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED")
        print("(STEP 1B/33) OF SHOOT2NINE4SEARCH - QUEUE2NINE: ", queue2nine)
        print("(STEP 1C/33) OF SHOOT2NINE4SEARCH - CONSUMER_CHANNEL2NINE: ", consumer_channel2nine) 
        print("(STEP 1D/33) OF SHOOT2NINE4SEARCH - PUBLISHER_CHANNEL2NINE: ", publisher_channel2nine)
        print("(STEP 1E/33) OF SHOOT2NINE4SEARCH - PATH2NINE: ", path2nine)     
        
        return
 
    if (not (queue2nine is None) and not(consumer_channel2nine is None) and not(publisher_channel2nine is None) and (path2nine is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL (CC) MECHANISM OK, BUT PATH MISSING - CAN BE USED FOR TESTING CC 
        # -----------------------------------------------------------------------------------------
        print("(STEP 2A/33) OF SHOOT2NINE4SEARCH - COMMAND AND CONTROL MECHANISM OK, BUT PATH MISSING")                       
        print("(STEP 2B/33) OF SHOOT2NINE4SEARCH - QUEUE2NINE: ", queue2nine)
        print("(STEP 2C/33) OF SHOOT2NINE4SEARCH - CONSUMER_CHANNEL2NINE: ", consumer_channel2nine) 
        print("(STEP 2D/33) OF SHOOT2NINE4SEARCH - PUBLISHER_CHANNEL2NINE: ", publisher_channel2nine)
        print("(STEP 2E/33) OF SHOOT2NINE4SEARCH - PATH2NINE: ", path2nine)     
        return           

    if (not (queue2nine is None) and not(consumer_channel2nine is None) and not(publisher_channel2nine is None) and not(path2nine is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN - PRODUCTION VERSION
        # -----------------------------------------------------------------------------------------
        print("(STEP 3A/33) OF SHOOT2NINE4SEARCH - COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN")                       
        
        print("(STEP 3B/33) OF SHOOT2NINE4SEARCH - QUEUE2NINE: ", queue2nine)
        # QUEUE2NINE:  <queue4xi.Queue4Xi object at 0x02A5D930>
         
        print("(STEP 3C/33) OF SHOOT2NINE4SEARCH - CONSUMER_CHANNEL2NINE: ", consumer_channel2nine)
        # CONSUMER_CHANNEL2NINE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
        print("(STEP 3D/33) OF SHOOT2NINE4SEARCH - PUBLISHER_CHANNEL2NINE: ", publisher_channel2nine)
        # PUBLISHER_CHANNEL2NINE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>
        print("(STEP 3E/33) OF SHOOT2NINE4SEARCH - PATH2NINE: ", path2nine)
        # PATH2NINE:  F://temp//yophotos//test2nine//
       
        print("(STEP 4A/33) OF SHOOT2NINE4SEARCH - STARTING TO WALK PATH2NINE: ", path2nine)   
        # STARTING TO WALK PATH2NINE:  F://temp//yophotos//test2nine//
        
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4nine = None
        try:
            name2index4nine = "index2xxxxxxxx4yo.html"
            path2index4nine = path2nine + name2index4nine
            print("(Step 4B/33) OF SHOOT2NINE4SEARCH - SET PATH2INDEX4NINE TO: ", path2index4nine)
            # R://temp//yophotos//test//index2xxxxxxxx4yo.html
        except:
            print("(Step 4Z1/33) OF SHOOT2NINE4SEARCH *** FAILED TO INITIALIZE PATH2INDEX4NINE: ", path2index4nine)          
            #                    
        fileobject4nine = None
        try:
            fileobject4nine = open(path2index4nine,'w')
            print("(Step 4C/33) OF SHOOT2NINE4SEARCH - OPENED OUTPUT: ", fileobject4nine)
            # SHOOT2NINE4SEARCH - OPENED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2nine//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
        except:
            print("(Step 4Z2/33) OF SHOOT2NINE4SEARCH *** FAILED TO OPEN OUTPUT: ", fileobject4nine)         
            # 
        try:                
            fileobject4nine.write('<html>\n')
            
            fileobject4nine.write('<style type="text/css" media="all">\n')
            fileobject4nine.write(' @import "http://www.yourninexi.org/css/halongbay.css";\n')
            fileobject4nine.write('</style> \n')
            fileobject4nine.write('<p>\n')
            fileobject4nine.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4nine.write('<br /><a id="000">yournine<b>&Xi;</b> @Content</a>\n')
            fileobject4nine.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4nine.write('<br /> \n')

        except:
            print("(Step 4Z3/33) OF SHOOT2NINE4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4nine)         
            #      
        
        
        KB2name4nine = {}
        key2name4nine = 0
                 
        for file2walk in DirectoryWalker(path2nine):
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                try:    
                    KB2name4nine [key2name4nine] = file2walk
                    print ("KB2NAME4NINE[", key2name4nine, "]: ", KB2name4nine [key2name4nine])
                    # 
                    
                    key2name4nine = key2name4nine + 1

                except:
                    print ("(Step 4Z1/33) OF SHOOT2NINE4SEARCH - FAILED UPDATING KB2NAME4NINE WITH FILE2WALK: " + file2walk + '\n')     
            else:
                build2hyperlink4nine(file2walk)
        
        # --------------------------------------------------------------------------------------------- 
        # END
        # --------------------------------------------------------------------------------------------- 
        try:
            fileobject4nine.write('<br /> \n')
            fileobject4nine.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4nine.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4nine.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject4nine.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4nine.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject4nine.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4nine.write('</p>\n')
            # 
            fileobject4nine.write('</html>\n')
        except:
            print("(Step 4Z4/33) OF SHOOT2NINE4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4nine)         
            #            
        try:    
            fileobject4nine.close()
            print("(Step 4C/33) OF SHOOT2NINE4SEARCH - CLOSED OUTPUT: ", fileobject4nine)         
            # SHOOT2NINE4SEARCH - CLOSED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2nine//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>   
        except:
            print("(Step 4Z5/33) OF SHOOT2NINE4SEARCH *** FAILED TO CLOSE OUTPUT: ", fileobject4nine)         
            #                  
                
                
        print("(STEP 5A/33) OF SHOOT2NINE4SEARCH - STARTING TO ANALYSE KB2NAME4NINE: ", time4xi())
        # STARTING TO ANALYSE KB2NAME4NINE:  11:44:16 01/20/15 FLE Standard Time
        
        AlphaKB4nine  = {}
        AlphaKB4nine['a'] = {}
        AlphaKB4nine['b'] = {}
        AlphaKB4nine['c'] = {}
        AlphaKB4nine['d'] = {}
        AlphaKB4nine['e'] = {}
        AlphaKB4nine['f'] = {}
        AlphaKB4nine['g'] = {}
        AlphaKB4nine['h'] = {}
        AlphaKB4nine['i'] = {}
        AlphaKB4nine['j'] = {}
        AlphaKB4nine['k'] = {}
        AlphaKB4nine['l'] = {}
        AlphaKB4nine['m'] = {}
        AlphaKB4nine['n'] = {}
        AlphaKB4nine['o'] = {}
        AlphaKB4nine['p'] = {}
        AlphaKB4nine['q'] = {}
        AlphaKB4nine['r'] = {}
        AlphaKB4nine['s'] = {}
        AlphaKB4nine['t'] = {}
        AlphaKB4nine['u'] = {}
        AlphaKB4nine['v'] = {}
        AlphaKB4nine['w'] = {}
        AlphaKB4nine['x'] = {}
        AlphaKB4nine['y'] = {}
        AlphaKB4nine['z'] = {} 
        keys2AlphaKB4nine = AlphaKB4nine.keys()
        key2AlphaKB4nine  = 0
        
        
        # LEVELS FOR PATH
        KB2level1 = {}
        KB2level2 = {}
        KB2level3 = {}
        KB2level4 = {}
        KB2level5 = {}
        KB2level6 = {}
        KB2level7 = {}
        KB2level8 = {}
        
        key2level1 = 0
        key2level2 = 0
        key2level3 = 0
        key2level4 = 0
        key2level5 = 0
        key2level6 = 0
        key2level7 = 0
        key2level8 = 0
        
        len2cut4nine = len(path2nine)
        # 
        
        keys2name4nine = KB2name4nine.keys()
                
        for key2name4nine in sorted(keys2name4nine):
            # 
            name2optimize4nine = KB2name4nine[key2name4nine]
            # 
            shortcut2level4nine = name2optimize4nine[len2cut4nine:]
            # 
            len2shortcut4nine = len(shortcut2level4nine)
            if len2shortcut4nine == 1:
                try:
                    # LEVEL NINE CONSISTS OF ALPHABETIC FOLDERS A ... Z
                    if shortcut2level4nine in keys2AlphaKB4nine:
                        KB2level1[key2level1] = shortcut2level4nine
                        # 
                        key2level1 = key2level1 + 1
                    else:
                        print ("(Step 5Z1/33) OF SHOOT2NINE4SEARCH ** WARNING - SHORTCUT2LEVEL4NINE: ", shortcut2level4nine, " NOT IN KEYS2ALPHAKB4NINE: ", keys2AlphaKB4nine)
                except:
                        print ("(Step 5Z2/33) OF SHOOT2NINE4SEARCH *** FAILED - SHORTCUT2LEVEL4NINE: ", shortcut2level4nine)      
            else:
                try:
                    
                    string2search4nine = '\\'
                    shortcut2level4nine = shortcut2level4nine[2:]
                    
                    index2level4nine=str.find(shortcut2level4nine,string2search4nine)
                    if index2level4nine == -1:
                         
                        KB2level2[key2level2] = shortcut2level4nine
                        key2level2 = key2level2 + 1
                    else:    
                        shortcut2level4nine = shortcut2level4nine[index2level4nine+1:]
                        index2level4nine=str.find(shortcut2level4nine,string2search4nine)
                        if index2level4nine == -1:
                            KB2level3[key2level3] = shortcut2level4nine
                            key2level3 = key2level3 + 1
                        else:
                            shortcut2level4nine = shortcut2level4nine[index2level4nine+1:]
                            index2level4nine=str.find(shortcut2level4nine,string2search4nine)
                            if index2level4nine == -1:
                                KB2level4[key2level4] = shortcut2level4nine
                                key2level4 = key2level4 + 1
                            else:
                                shortcut2level4nine = shortcut2level4nine[index2level4nine+1:]
                                index2level4nine=str.find(shortcut2level4nine,string2search4nine)
                                if index2level4nine == -1:
                                    KB2level5[key2level5] = shortcut2level4nine
                                    key2level5 = key2level5 + 1
                                else: 
                                    shortcut2level4nine = shortcut2level4nine[index2level4nine+1:]
                                    index2level4nine=str.find(shortcut2level4nine,string2search4nine)
                                    if index2level4nine == -1:
                                        KB2level6[key2level6] = shortcut2level4nine
                                        key2level6 = key2level6 + 1
                                    else:
                                        shortcut2level4nine = shortcut2level4nine[index2level4nine+1:]
                                        index2level4nine=str.find(shortcut2level4nine,string2search4nine)
                                        if index2level4nine == -1:
                                            KB2level7[key2level7] = shortcut2level4nine
                                            key2level7 = key2level7 + 1
                                        else:
                                            shortcut2level4nine = shortcut2level4nine[index2level4nine+1:]
                                            index2level4nine=str.find(shortcut2level4nine,string2search4nine)
                                            if index2level4nine == -1:
                                                KB2level8[key2level8] = shortcut2level4nine
                                                key2level8 = key2level8 + 1                
                                            else:
                                                print ("(Step 5Z2/33) OF SHOOT2NINE4SEARCH ** WARNING: MOTE THAN 8 LEVELS, SHORTCUT2LEVEL4NINE: ", shortcut2level4nine)
                except:
                    print ("(Step 5Z3/33) OF SHOOT2NINE4SEARCH *** FAILED - SHORTCUT2LEVEL4NINE: ", shortcut2level4nine)   
        
        print ("(Step 6A/33) OF SHOOT2NINE4SEARCH - TRYING TO PRINT KB2level1 ", time4xi())       
        # SHOOT2NINE4SEARCH - TRYING TO PRINT KB2level1  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level1 = KB2level1.keys()
            for key2Level1 in sorted(keys2Level1):
                print (KB2level1[key2Level1])      
                # a ... z          
        except:
            print ("(Step 6Z1/33) OF SHOOT2NINE4SEARCH *** FAILED TO PRINT KB2level1 ", time4xi())    

        print ("(Step 6B/33) OF SHOOT2NINE4SEARCH - TRYING TO PRINT KB2level2 ", time4xi())        
        # SHOOT2NINE4SEARCH - TRYING TO PRINT KB2level2  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level2 = KB2level2.keys()
            for key2Level2 in sorted(keys2Level2):
                print (KB2level2[key2Level2])      
                # ninefly29july2012    
        except:
            print ("(Step 6Z2/33) OF SHOOT2NINE4SEARCH *** FAILED TO PRINT KB2level2 ", time4xi()) 
            
        print ("(Step 6C/33) OF SHOOT2NINE4SEARCH - TRYING TO PRINT KB2level3 ", time4xi())       
        try:
            keys2Level3 = KB2level3.keys()
            for key2Level3 in sorted(keys2Level3):
                print (KB2level3[key2Level3])      
                # 
        except:
            print ("(Step 6Z3/33) OF SHOOT2NINE4SEARCH *** FAILED TO PRINT KB2level3 ", time4xi())             
        
        print ("(Step 6D/33) OF SHOOT2NINE4SEARCH - TRYING TO PRINT KB2level4 ", time4xi())       
        # 
        try:
            keys2Level4 = KB2level4.keys()
            for key2Level4 in sorted(keys2Level4):
                print (KB2level4[key2Level4])      
                #            
        except:
            print ("(Step 6Z4/33) OF SHOOT2NINE4SEARCH *** FAILED TO PRINT KB2level4 ", time4xi())                                         
        
        print ("(Step 6E/33) OF SHOOT2NINE4SEARCH - TRYING TO PRINT KB2level5 ", time4xi())       
        # 
        try:
            keys2Level5 = KB2level5.keys()
            for key2Level5 in sorted(keys2Level5):
                print (KB2level5[key2Level5])      
                #              
        except:
            print ("(Step 6Z5/33) OF SHOOT2NINE4SEARCH *** FAILED TO PRINT KB2level5 ", time4xi())             
        
        print ("(Step 6F/33) OF SHOOT2NINE4SEARCH - TRYING TO PRINT KB2level6 ", time4xi())       
        # 
        try:
            keys2Level6 = KB2level6.keys()
            for key2Level6 in sorted(keys2Level6):
                print (KB2level6[key2Level6])      
                #              
        except:
            print ("(Step 6Z6/33) OF SHOOT2NINE4SEARCH *** FAILED TO PRINT KB2level6 ", time4xi())             
    
        print ("(Step 6G/33) OF SHOOT2NINE4SEARCH - TRYING TO PRINT KB2level7 ", time4xi())       
        # 
        try:
            keys2Level7 = KB2level7.keys()
            for key2Level7 in sorted(keys2Level7):
                print (KB2level7[key2Level7])      
                #              
        except:
            print ("(Step 6Z7/33) OF SHOOT2NINE4SEARCH *** FAILED TO PRINT KB2level7 ", time4xi()) 
            
        print ("(Step 6H/33) OF SHOOT2NINE4SEARCH - TRYING TO PRINT KB2level8 ", time4xi())       
        # 
        try:
            keys2Level8 = KB2level8.keys()
            for key2Level8 in sorted(keys2Level8):
                print (KB2level8[key2Level8])      
                #              
        except:
            print ("(Step 6Z8/33) OF SHOOT2NINE4SEARCH *** FAILED TO PRINT KB2level8 ", time4xi())         
        
        print ("(Step 7A/33) OF SHOOT2NINE4SEARCH - TRYING TO PRINT STATISTICS ", time4xi())   
        #     
        try:    
            print ("(Step 7B/33) OF SHOOT2NINE4SEARCH - COUNT2ACK4NINE; ", count2ack4nine)
            # COUNT2ACK4NINE;  3 <-- *.jpg
            print ("(Step 7C/33) OF SHOOT2NINE4SEARCH - COUNT2NACK4NINE; ", count2nack4nine)
            # COUNT2NACK4NINE;  2 <-- index.html
            print ("(Step 7D/33) OF SHOOT2NINE4SEARCH - COUNT2FOUND4NINE: ", count2found4nine)
            # COUNT2FOUND4NINE:  5 <-- all files
        except:
             print ("(Step 7Z1/33) OF SHOOT2NINE4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:  
            print ("(Step 7E/33) OF SHOOT2NINE4SEARCH - FOUND MAX SIZE: ", maxsize2ack4nine)
            #  3866624
            print ("(Step 7F/33) OF SHOOT2NINE4SEARCH - ALLOWED MAX SIZE: ", maxsize2file4nine)
            # 33000000
        except:
             print ("(Step 7Z2/33) OF SHOOT2NINE4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:         
            if count2found4nine == 0:
                meansize2ack4nine = 0
                print ("(Step 7G1/33) OF SHOOT2NINE4SEARCH - MEAN SIZE SET: ", meansize2ack4nine)
                #  
            else:       
                meansize2ack4nine = int(sumsize2ack4nine / count2ack4nine)
                print ("(Step 7G2/33) OF SHOOT2NINE4SEARCH - MEAN SIZE CALCULATED: ", meansize2ack4nine, ", WHERE SUMSIZE2ACK4NINE: ", sumsize2ack4nine, " COUNT2ACK4NINE: ", count2ack4nine)
                # MEAN SIZE CALCULATED:  3648170 , WHERE SUMSIZE2ACK4NINE:  10944512  COUNT2ACK4NINE:  3 
        except:
             print ("(Step 7Z3/33) OF SHOOT2NINE4SEARCH *** FAILED TO CALCULATE STATISTICS ", time4xi())
        
        try:                 
            if minsize2ack4nine < maxsize2file4nine:
                print ("(Step 7H/33) OF SHOOT2NINE4SEARCH - MIN SIZE MET: ", minsize2ack4nine)
                # 3538944
            else:
                print ("(Step 7I/33) OF SHOOT2NINE4SEARCH ** MIN DEFINED: ", minsize2ack4nine, " EQUALS TO MAXSIZE2FILE4NINE: ", maxsize2file4nine)        
        except:
             print ("(Step 7Z4/33) OF SHOOT2NINE4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
             
                         
        print("(STEP 4Y/33) OF SHOOT2NINE4SEARCH - RETURNING: ", time4xi(), " HAVING STARTED: ", time2start) 
        # 12:26:08 01/20/15 FLE Standard Time  HAVING STARTED:  12:26:08 01/20/15 FLE Standard Time
 
        
               
        return
    else:
        # -----------------------------------------------------------------------------------------
        # UNEXPECTED PARAMETER COMBINATION - ERROR
        # -----------------------------------------------------------------------------------------
        print("(STEP 7Z1/33) OF SHOOT2NINE4SEARCH *** ERROR IN LOGIC ***")
        print("(STEP 7Z2/33) OF SHOOT2NINE4SEARCH - QUEUE2NINE: ", queue2nine)
        print("(STEP 7Z3/33) OF SHOOT2NINE4SEARCH - CONSUMER_CHANNEL2NINE: ", consumer_channel2nine) 
        print("(STEP 7Z4/33) OF SHOOT2NINE4SEARCH - PUBLISHER_CHANNEL2NINE: ", publisher_channel2nine)
        print("(STEP 7Z5/33) OF SHOOT2NINE4SEARCH - PATH2NINE: ", path2nine)     
              
        return  
            
               
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\analyse2photo4search.txt
# \xml\ace-analyse2photo.xml
# \xml\reason-analyse2photo.xml
# \xml\sense-analyse2photo.xml
# 
#"
#>
  

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.ninexi.com; www.yourninexi.com; www.yourninexi.org; www.nine2xi.com/; www.nine4xi.com/; www.nine8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2nine4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
